<ion-content class="ion-padding">
    <ion-grid>
        <ion-row>
            <ion-col></ion-col>
            <ion-col size="6"></ion-col>
            <ion-col class="header">score</ion-col>
            <ion-col class="header">par</ion-col>
            <ion-col class="header">+-</ion-col>
        </ion-row>
        {#each scores as score, index}
        <ion-row on:click={ () => toggleExpanded(index) }>
            <ion-col on:click>{index + 1}</ion-col>
            <ion-col size="6">{score.playerName}</ion-col>
            <ion-col>{score.score}</ion-col>
            <ion-col>{score.par}</ion-col>
            <ion-col>{scoreToPar(score)}</ion-col>
        </ion-row>
        {#if score.expanded === true}
        <ion-row transition:grow|local style="overflow:hidden;">
       <!--  TODO: make this more vertical -->
            <div> Course Name: {score.courseName} </div>
            <div> Rating: {score.courseRating} </div>
            <div> Slope: {score.courseSlope} </div>
        </ion-row>
        {/if}
        {/each}
    </ion-grid>
    <br>
    <br>
    <OnlyIfInRole role={[Role.PLAYER, Role.ORGANIZER]}>
        {#if outing}
        <ion-button expand=block on:click={() => navigateTo('reportScore', {id: outing._id}) }>Report a Score</ion-button>
        {/if}
    </OnlyIfInRole>
    <OnlyIfInRole role={Role.ORGANIZER}>
        <ion-button expand=block on:click={() => navigateTo('invite', {id: outing._id}) }>Invite Players</ion-button>
    </OnlyIfInRole>
</ion-content>

<script>
import {scoresStore} from '/client/ScoresStore'
import {activeOutingStore} from '/client/OutingsStore'
import {navigateTo} from 'svelte-grouter'
import OnlyIfInRole from '/client/components/OnlyIfInRole'
import {Role} from '/lib/Roles'
import {layoutStore} from '/client/LayoutStore'

$layoutStore.showBack = true
$: outing = $activeOutingStore
$: if (outing) {
    $layoutStore.title = outing.name
}

$: scores = $scoresStore.sort((a, b) => scoreToPar(a) - scoreToPar(b))

function scoreToPar(score) {
    return score.score - score.par
}

function toggleExpanded(scoreIndex){
    scores[scoreIndex].expanded = !scores[scoreIndex].expanded
}

function grow(node, {delay = 0,	duration = 200}) {
	return {
		delay,
		duration,
		css: t => `max-height: ${t * node.offsetHeight}px`
	};
}
</script>

<style>
.header {
    color: #999999
}
</style>